//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Tue May 27 11:12:44 2008 by ROOT version 5.18/00
// from TTree ntuple/root tree from ascii file
// found on file: data.root
//////////////////////////////////////////////////////////

#ifndef PSECNtupleAna_h
#define PSECNtupleAna_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <string>

class PSECNtupleAna {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain

   // Declaration of leaf types
   Float_t         data_RunNum;
   Float_t         data_RunTyp;
   Float_t         data_EventNum;
   Float_t         data_BufferSequenceN;
   Float_t         data_RealTimeLR;
   Float_t         data_RTimeHR;
   Float_t         data_LrRamp;
   Float_t         data_HrRamp;
   Float_t         data_TAC1Tim;
   Float_t         data_TAC2Tim;
   Float_t         data_TAC3Tim;
   Float_t         data_Dev1Ph;
   Float_t         data_Dev2Ph;
   Float_t         data_Scaler1;
   Float_t         data_Scaler2;
   Float_t         data_Scaler3;

   // Declaration of computed variables
   Float_t	   computed_UniqueEventNum;
   Float_t	   computed_LrRampDiff;
   Float_t	   computed_HrRampDiff;
   Float_t	   computed_TAC23Tim;
   Float_t	   computed_IsTAC1Fired;
   Float_t	   computed_IsTAC2Fired;
   Float_t	   computed_IsTAC3Fired;
   Float_t	   computed_NTACFired;

//   static COMPUTED computed;

   // List of branches
   TBranch        *b_data;   //!
   TBranch	  *b_computed;	//!

   PSECNtupleAna(TTree *tree=0);
   virtual ~PSECNtupleAna();
   virtual Int_t    Cut(Long64_t entry);
   virtual Int_t    GetEntry(Long64_t entry);
   virtual Long64_t LoadTree(Long64_t entry);
   virtual void     Init(TTree *tree);
   virtual void     Loop(const char* OutHistos, const char* OutSummary, const char* OutImage);
   virtual Bool_t   Notify();
   virtual void     Show(Long64_t entry = -1);
};

#endif

#ifdef PSECNtupleAna_cxx
PSECNtupleAna::PSECNtupleAna(TTree *tree)
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   if (tree == 0) {
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("data.root");
      if (!f) {
         f = new TFile("data.root");
      }
      tree = (TTree*)gDirectory->Get("ntuple");

   }
   Init(tree);
}

PSECNtupleAna::~PSECNtupleAna()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t PSECNtupleAna::GetEntry(Long64_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Long64_t PSECNtupleAna::LoadTree(Long64_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Long64_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (!fChain->InheritsFrom(TChain::Class()))  return centry;
   TChain *chain = (TChain*)fChain;
   if (chain->GetTreeNumber() != fCurrent) {
      fCurrent = chain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void PSECNtupleAna::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses and branch
   // pointers of the tree will be set.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   // Set branch addresses and branch pointers
   if (!tree) return;
   fChain = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("data", &data_RunNum, &b_data);
   fChain->SetBranchAddress("computed", &computed_UniqueEventNum, &b_computed);
   Notify();
}

Bool_t PSECNtupleAna::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

void PSECNtupleAna::Show(Long64_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t PSECNtupleAna::Cut(Long64_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}
#endif // #ifdef PSECNtupleAna_cxx
