#include <iostream>
#include <iomanip>
//#include "histogram.h"
#include <string>
#include "TFile.h"
#include "TTree.h"
#include "TNtuple.h"
#include "Riostream.h"

#define TAB '\t'

//Purpose : This program reads an ascii file formatted as indicated in tupleFormat.txt
//	    and outputs the data in a root file.

//Modified May 14 2008 Emilien Chapon

//Modified May 22 2008 Emilien Chapon: support for new type of data

using namespace std;

TTree* convert(const char* infile, const char* outfile)	{

	ifstream in;
//	string namefile;
//	cin >> namefile;
//	in.open("ntuple.ascii.all");
	in.open(infile);

	int tupleCount=0;
/*	float talim = 0.0, tblim=0.0; // run_047
	float qalim = 3000.0, qblim=3020.0; // run_047
	float t1mean = 7674.0;
	float t2mean = 6891.0;
	float q1mean = 392.0;
	float q2mean = 377.0;
*/
	typedef struct {float RunNumber, RunType, EventNumber, BufferSequenceNumber, BufferStartTimeLR, BufferStartTimeHR, BufferEndTimeLR,
		BufferEndTimeHR, RampTimeAdc, Mcp1TimeAdc, Mcp1PhAdc, Mcp2TimeAdc, Mcp2PhAdc, Mcp3TimeAdc, Mcp3PhAdc, 
		Mcp4TimeAdc, Mcp4PhAdc, Trig1TimeTdc, Trig2TimeTdc, CherenkovTimeTdc;} DATA;

	static DATA data;
	
//	TFile *f = new TFile("PSECNtuple.root","RECREATE");
	TFile *f = new TFile(outfile,"RECREATE");
	/*TNtuple *ntuple = new TNtuple("ntuple","data from ascii
	 file","RunNumber:RunType:EventNumber:BufferSequenceNumber:BufferStartTimeLR:BufferStartTimeHR:BufferEndTimeLR");//:BufferEndTimeHR:RampTimeAdc:Mcp1TimeAdc:Mcp1PhAdc:Mcp2TimeAdc:Mcp2PhAdc:Mcp3TimeAdc:Mcp3PhAdc:Mcp4TimeAdc:Mcp4PhAdc:Trig1TimeTdc:Trig2TimeTdc:CherenkovTimeTdc");
*/
	TTree *ntuple = new TTree("ntuple","root tree from ascii file");
	ntuple->Branch("data",&data,"RunNumber:RunType:EventNumber:BufferSequenceNumber:BufferStartTimeLR:BufferStartTimeHR:BufferEndTimeLR:BufferEndTimeHR:RampTimeAdc:Mcp1TimeAdc:Mcp1PhAdc:Mcp2TimeAdc:Mcp2PhAdc:Mcp3TimeAdc:Mcp3PhAdc:Mcp4TimeAdc:Mcp4PhAdc:Trig1TimeTdc:Trig2TimeTdc:CherenkovTimeTdc");

string null;
in >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null >> null;

   while(1) {

	in >> data.RunNumber >> data.RunType >> data.EventNumber >> data.BufferSequenceNumber >> data.BufferStartTimeLR >>
	   data.BufferStartTimeHR >> data.BufferEndTimeLR >> data.BufferEndTimeHR >> data.RampTimeAdc >> data.Mcp1TimeAdc >> 
	   data.Mcp1PhAdc >> data.Mcp2TimeAdc >> data.Mcp2PhAdc >> data.Mcp3TimeAdc >> data.Mcp3PhAdc >> data.Mcp4TimeAdc >> 
	   data.Mcp4PhAdc >> data.Trig1TimeTdc >> data.Trig2TimeTdc >> data.CherenkovTimeTdc;

	// detect an EOF
//        if ( cin.eof() != 0 ) {
//                cout << "Found end of file..." << endl;
//                break;
//        }
	if (!in.good()) break;
	/*ntuple->Fill(RunNumber,RunType,EventNumber,BufferSequenceNumber,BufferStartTimeLR,BufferStartTimeHR,BufferEndTimeLR,
		BufferEndTimeHR,RampTimeAdc,Mcp1TimeAdc,Mcp1PhAdc,Mcp2TimeAdc,Mcp2PhAdc,Mcp3TimeAdc,Mcp3PhAdc,
		Mcp4TimeAdc,Mcp4PhAdc,Trig1TimeTdc,Trig2TimeTdc,CherenkovTimeTdc);
*/
	ntuple->Fill();
	tupleCount++;
/*	if (tupleCount < 5) {
	   cout << " " << data.RunNumber << " " << data.RunType << " " << data.EventNumber << " " << data.BufferSequenceNumber << " " << data.BufferStartTimeLR << " " << data.BufferStartTimeHR << " " << data.BufferEndTimeLR << " " << data.BufferEndTimeHR << " " << data.RampTimeAdc << " " << data.Mcp1TimeAdc << " " << data.Mcp1PhAdc << " " << data.Mcp2TimeAdc << " " << data.Mcp2PhAdc << " " << data.Mcp3TimeAdc << " " << data.Mcp3PhAdc << " " << data.Mcp4TimeAdc << " " << data.Mcp4PhAdc << " " << data.Trig1TimeTdc << " " << data.Trig2TimeTdc << " " << data.CherenkovTimeTdc << endl; 
	}
*/

   } // end of forever loop

	cout << "Found " << tupleCount  << " lines."  << endl;

	in.close();
	f->Write();
//	f->Close();
	return ntuple;
}
