#include <TH2.h>
#include <TStyle.h>
#include <TCanvas.h>
#include <TBrowser.h>
#include <TList.h>
#include <TFile.h>
#include <TStyle.h>
#include <TChain.h>
#include <TDatime.h>
#include <TGLabel.h>
#include <TCanvas.h>
#include <TSystem.h>
#include <TGMenu.h>
#include <TGButton.h>
#include <TGSplitter.h>
#include <TGListTree.h>
#include <TStopwatch.h>
#include <TSystemFile.h>
#include <TApplication.h>
#include <TGTextView.h>
#include <TGFileDialog.h>
#include <TGComboBox.h>
#include <TGProgressBar.h>
#include <TGButtonGroup.h>
#include <TSystemDirectory.h>
#include <TRootEmbeddedCanvas.h>
#include <TLatex.h>
#include <TPad.h>
#include <TApplication.h> 
#include <TGClient.h>
#include "Display.h"

MyMainFrame::MyMainFrame(const TGWindow *p, UInt_t w, UInt_t h)
    : TGMainFrame(p, w, h)
{
    // Create a main frame with a number of different buttons.

    fButton1 = new TGTextButton(this, "&Version", 1);
    fButton1->SetCommand("printf(\"This is ROOT version %s\\n\","
                          "gROOT->GetVersion());");
    fButton2 = new TGTextButton(this, "&Exit", 2);
    fButton2->SetCommand(".q" );
    fPicBut = new TGPictureButton(this, gClient->GetPicture("world.xpm"), 3);
    fPicBut->SetCommand("printf(\"hello world!\\n\");");
    fChkBut = new TGCheckButton(this, "Check Button", 4);
    fRBut1 = new TGRadioButton(this, "Radio Button 1", 5);
    fRBut2 = new TGRadioButton(this, "Radio Button 2", 6);
    fLayout = new TGLayoutHints(kLHintsCenterX | kLHintsCenterY);

    AddFrame(fButton1, fLayout);
    AddFrame(fPicBut, fLayout);
    AddFrame(fButton2, fLayout);
    AddFrame(fChkBut, fLayout);
    AddFrame(fRBut1, fLayout);
    AddFrame(fRBut2, fLayout);

    MapSubwindows();

    Layout();

    SetWindowName("Button Example");
    SetIconName("Button Example");

    MapWindow();
}

Bool_t MyMainFrame::ProcessMessage(Long_t msg, Long_t parm1, Long_t)
{
    // Process events generated by the buttons in the frame.

    switch (GET_MSG(msg)) {
        case kC_COMMAND:
            switch (GET_SUBMSG(msg)) {
                case kCM_BUTTON:
                    printf("text button id %ld pressed\n", parm1);
                    break;
                case kCM_CHECKBUTTON:
                    printf("check button id %ld pressed\n", parm1);
                    break;
                case kCM_RADIOBUTTON:
                    if (parm1 == 5)
                        fRBut2->SetState(kButtonUp);
                    if (parm1 == 6)
                        fRBut1->SetState(kButtonUp);
                    printf("radio button id %ld pressed\n", parm1);
                    break;
                default:
                    break;
            }
        default:
            break;
    }
    return kTRUE;
}
