#!/bin/bash

#This script is intented to write comments on the database.comments file.

#Display what has been said before
if test -f database.comments
then
	echo "Here's what has already been written in database.comments:"
	tail database.comments
else
	echo "database.comments file not found. No comments were written before."
fi

#Set the run number. For that we read the previous run number from the database, provided it already exists.

if test -f database.db ;
then
	RUN_NUMBER=$(tail -n 1 database.db | sed -e 's/ .*//')
else
	echo "warning, couldn't find the database"
	RUN_NUMBER=0
fi

#determine if a run is currently running or not
#if a run is running, then TYPE is set to  2
#else it is set to 0
if ps aux | grep "[0-9] daq_run.sh" >> /dev/null ;
then
	TYPE=2
else
	TYPE=0
fi

CONTINUE=true
echo -e "Type your comments here. Juste type \"STOP\" when you're finished."
while $CONTINUE ; do
	read COMMENT
	if [ "$COMMENT" = "STOP" ] ;
	then
		CONTINUE=false
	else
		echo -e $RUN_NUMBER '\t' $TYPE '\t' $(date '+%T') $(date '+%D') '\t' $(date '+%s') '\t' $COMMENT >> database.comments
	fi
done