#!/bin/bash

#This script is intented updating the database if needed during or between runs.
#It writes environmental variables (temperature, ...) to the database.

#Written by Emilien Chapon, June 13, 2008

#First, set the run number. For that we read the previous run number from the database, provided it already exists.
if test -f database.db ;
then
	RUN_NUMBER=$(tail -n 1 database.db | sed -e 's/ .*//')
	RUN_NUMBER=`expr $RUN_NUMBER \+ 1`
else
	echo "warning, couldn't find the database, creating a new one"
	RUN_NUMBER=10
fi

#determine if a run is currently running or not
#if a run is running, then TYPE is set to  2
#else it is set to 0
if ps aux | grep "[0-9] daq_run.sh" >> /dev/null ;
then
	TYPE=2
else
	TYPE=0
fi

#Check if the database is blocked
while test -f databse.db.lock ; do
	echo 'warning, database is locked'
	sleep 1
done
echo > database.db.lock
echo -e $RUN_NUMBER '\t' $TYPE '\t' $(date '+%T') '\t' $(date '+%D') '\t' $(date '+%s') '\t' $(exec acread2 I:Beam) '\t' $(exec acread2 F:MW1SEM) '\t' $(exec acread2 F:MC1SEM) '\t' $(exec acread2 F:MC6IC) '\t' $(exec acread2 F:MT5EL) '\t' $(exec acread2 F:MT5E) '\t' $(exec acread2 F:MT4PB) '\t' $(exec acread2 F:MT6AB1) '\t' $(exec acread2 F:MT6AB2) '\t' $(exec acread2 F:MT6TP1) '\t' $(exec acread2 F:MT6TP2) '\t' $(exec acread2 F:MT5CC) '\t' $(exec acread2 F:MT6CC) '\t' $(exec acread2 F:MT6SC1) '\t' $(exec acread2 F:MT6SC2) '\t' $(exec acread2 F:MTSCL1) '\t' $(exec acread2 F:MTSCL2) '\t' $(exec acread2 F:MTSCL3) '\t' $(exec acread2 F:MTSCL4) '\t' $(exec acread2 F:MTSCL5) '\t' $(exec acread2 F:MTSCL6) '\t' $(exec acread2 F:MTSCL7) '\t' $(exec acread2 F:MTSCL8) '\t' $(exec acread2 F:MT5CPR) '\t' $(exec acread2 F:MT6CPR) >> database.db
rm database.db.lock
echo wrote the following line to database:
tail -n 1 database.db

echo End of script
