#include <iostream>
#include <iomanip>
#include <string>
#include "Riostream.h"

#define TAB '\t'

//Purpose : This program reads the database and ouputs an ascii ntuple according to what fields the user asks for.

//Usage: db2ntuple database.db ntuple.out

//Modified June 6 2008 Emilien Chapon

using namespace std;

int main(int argc, char* argv[])
{
	if(argc != 3){
		cout << "Warning, bad number of arguments" << endl;
		cout << "Usage: db2ntuple database.db ntuple.out" << endl;
		return 1;
	}

	ifstream in;
	in.open(argv[1]);

	ofstream outfile (argv[2], ios::out);
	string outscheme=argv[2];
	outscheme=outscheme + ".scheme";
	ofstream outfilescheme (outscheme.c_str(), ios::out);


	int tupleCount=0;

	int Run_Number, Run_Moment;
	string hour, date, seconds_since_01_01_1970;
	float I_Beam, F_MW1SEM, F_MC1SEM, F_MC6IC, F_MT6TP1, F_MT6TP2, F_MTSCL1;
	int Run_Number_b, Run_Moment_b, hour_b, date_b, seconds_since_01_01_1970_b, I_Beam_b, F_MW1SEM_b, F_MC1SEM_b, F_MC6IC_b, F_MT6TP1_b, F_MT6TP2_b, F_MTSCL1_b;


	cout << "For each of the following variables, please type 1 if you want to include them in the ntuple, else 0" << endl;
	outfilescheme << "List of parameters used in " << argv[2] << " :" << endl << endl;
	cout << "Run_Number" << endl;
	cin >> Run_Number_b;
	if (Run_Number_b) outfilescheme << "Run_Number" << endl;
	cout << "Run_Moment" << endl;
	cin >> Run_Moment_b;
	if (Run_Moment_b) outfilescheme << "Run_Moment" << endl;
	cout << "hour : format hh:mm:ss (24H hour format)" << endl;
	cin >> hour_b;
	if(hour_b) outfilescheme << "hour : format hh:mm:ss (24H hour format)" << endl;
	cout << "date : format mm/dd/yy" << endl;
	cin >> date_b;
	if(date_b) outfilescheme << "date : format mm/dd/yy" << endl;
	cout << "seconds_since_01/01/1970 : number of seconds since then" << endl;
	cin >> seconds_since_01_01_1970_b;
	if(seconds_since_01_01_1970_b) outfilescheme << "seconds_since_01/01/1970 : number of seconds since then" << endl;
	cout << "I:Beam : Amount of beam in Main Injector (unit : E12)" << endl;
	cin >> I_Beam_b;
	if(I_Beam_b) outfilescheme << "I:Beam : Amount of beam in Main Injector (unit : E12)" << endl;
	cout << "F:MW1SEM : Beam at west split (unit : ppp)" << endl;
	cin >> F_MW1SEM_b;
	if(F_MW1SEM_b) outfilescheme << "F:MW1SEM : Beam at west split (unit : ppp)" << endl;
	cout << "F:MC1SEM : (unit : Prts)" << endl;
	cin >> F_MC1SEM_b;
	if(F_MC1SEM_b) outfilescheme << "F:MC1SEM : (unit : Prts)" << endl;
	cout << "F:MC6IC : (unit : ppp)" << endl;
	cin >> F_MC6IC_b;
	if(F_MC6IC_b) outfilescheme << "F:MC6IC : (unit : ppp)" << endl;
	cout << "F:MT6TP1 : Room temp upstream (unit : DegC)" << endl;
	cin >> F_MT6TP1_b;
	if(F_MT6TP1_b) outfilescheme << "F:MT6TP1 : Room temp upstream (unit : DegC)" << endl;
	cout << "F:MT6TP2 : Room temp downstream (unit : DegC)" << endl;
	if(F_MT6TP2_b) outfilescheme << "F:MT6TP2 : Room temp downstream (unit : DegC)" << endl;
	cin >> F_MT6TP2_b;
	cout << "F:MTSCL1 : Scaler 1 in MT6 (unit : Cnts)" << endl;
	cin >> F_MTSCL1_b;
	if(F_MTSCL1_b) outfilescheme << "F:MTSCL1 : Scaler 1 in MT6 (unit : Cnts)" << endl;



   while(1) {

	in >> Run_Number >> Run_Moment >> hour >> date >> seconds_since_01_01_1970 >> I_Beam >> F_MW1SEM >> F_MC1SEM >> F_MC6IC >> F_MT6TP1 >> F_MT6TP2 >> F_MTSCL1;

	if (!in.good()) break;

	if(Run_Number_b) outfile << Run_Number << "\t";
	if(Run_Moment_b) outfile << Run_Moment << "\t";
	if(hour_b) outfile << hour << "\t";
	if(date_b) outfile << date << "\t";
	if(seconds_since_01_01_1970_b) outfile << seconds_since_01_01_1970 << "\t";
	if(I_Beam_b) outfile << I_Beam << "\t";
	if(F_MW1SEM_b) outfile << F_MW1SEM << "\t";
	if(F_MC1SEM_b) outfile << F_MC1SEM << "\t";
	if(F_MC6IC_b) outfile << F_MC6IC << "\t";
	if(F_MT6TP1_b) outfile << F_MT6TP1 << "\t";
	if(F_MT6TP2_b) outfile << F_MT6TP2 << "\t";
	if(F_MTSCL1_b) outfile << F_MTSCL1 << "\t";
	outfile << endl;
	tupleCount++;


   } // end of forever loop

	cout << "Found " << tupleCount  << " lines."  << endl;

	in.close();
	return 0;
}
